function y = from_datacube(Y);

%Converts a standard wavelet datacube into a vector with the 
numbering scheme given in 'An exact tree projection algorithm 
for wavelets' (C. Cartis, A. Thompson, 2013)

N = size(Y,1);
J = log2(N);
D = ndims(Y);

for i = 1:N^D

rem = 0;

max_rem(i) = 0;

x = i-1;

while (x > 0)
rem = mod(x,N);
max_rem(i) = max(max_rem(i),rem);
x = (x - rem)/N;
end

end

y = Y(1);

for level = 1:J

new_set = intersect(find(max_rem<=2^level-1),find(max_rem>=2^(level-1)))';
y = [y; Y(new_set)];

end


