function Y = to_datacube(y,N)

%Converts a vector with the numbering scheme given in an 'An exact
 tree projection for wavelets' (C. Cartis/A. Thompson 2013) into a 
 datacube of length N. Note: N must satisfy M = N^D for some D, 
 where M is the length of y.

M = length(y);
D = log2(M)/log2(N);
J = log2(N);

for i = 1:M

rem = 0;

max_rem(i) = 0;

x = i-1;

while (x > 0)
rem = mod(x,N);
max_rem(i) = max(max_rem(i),rem);
x = (x - rem)/N;
end

end

Y(1) = y(1);

for level = 1:J

in_level = (intersect(find(max_rem>=2^(level-1)),find(max_rem<=2^level-1)))';
y_level = y(2^(D*(level-1))+1:2^(D*level));
Y(in_level) = y_level;

end

reshape_dims = N*ones(1,D);
Y = reshape(Y,reshape_dims);


